Composer integration for Contao
===============================

Module which loads the Composer autoloader, creates initial composer.json and provides a back end client.

![Back end module](http://c-c-a.org/files/standard/publisher/images/composer.png)

### Installation

##### Checkout repository

Checkout this repository and link it to system/modules (initial)

```
cd /path/to/my/project/documentroot
git clone git@github.com:contao-community-alliance/composer.git composer/vendor/contao-community-alliance/composer
cd system/modules
ln -s ../../composer/vendor/contao-community-alliance/composer/src/system/modules/\!composer .
cd ../..
```

##### Contao page request

Do a normal page request, this will prepare the folder structure and the default composer.json

##### Download Composer (the manual way)

Download Composer as explained here: http://getcomposer.org/doc/00-intro.md#downloading-the-composer-executable

```
cd composer
curl -sS https://getcomposer.org/installer | php
```

##### Download Composer (with back end client)

Just call the back end client from the menu, it will tell you that Composer is not installed and install it automatically.

##### Add some vendors (the manual way)

Open the composer/composer.json in your prefered editor and add some dependencies as explained here: http://getcomposer.org/doc/04-schema.md

```json
{
    "require": {
        "bit3/contao-nested-menu": "dev-master"
    }
}
```

##### Add some vendors (with back end client)

###### Via integrated search

Type your keyword or package name into the search field and press the search button.

![Package search](http://img705.imageshack.us/img705/5623/composer3.png)

Select your package and click the "mark to install" button on the right.
Select prefered version and version contraint to install.

![Package details view](http://img547.imageshack.us/img547/1969/composer4.png)

###### Via integrated editor

![Advanced editor](http://img199.imageshack.us/img199/9184/composer2.png)

Click on "advanced mode" in the back end client and add some dependencies as explained here: http://getcomposer.org/doc/04-schema.md

```json
"require": {
    ...
   "bit3/contao-nested-menu": "dev-master" 
}
```

##### Install the vendors (the manual way)

Tell composer to download the configured vendors

```
php composer.phar install
```

##### Install the vendors (with back end client)

Click on "updated packages" and just wait until Composer finished installation.

### Requirements
* PHP 5.3.4 or higher
* Contao 2.11.* or Contao 3.1.* or higher

Attribution
-----------

* Module Icon (src/system/modules/!composer/assets/images/type-library.png) licensed under Public Domain by Icojam (http://www.iconarchive.com/show/blue-bits-icons-by-icojam/module-puzzle-icon.html)
* Composer Icon (src/system/modules/!composer/assets/images/type-library.png) from (https://github.com/composer/getcomposer.org)
* Component Icon (src/system/modules/!composer/assets/images/type-component.png) licensed unter CC Attribution 3.0 by Farm Fresh Icons (http://www.fatcow.com/free-icons)
